var shiori_array = null;

function shiori_normalizeURL(url) {
  return url.replace(/#.*$/g, "").replace(/ /g, "%20");
}

function shiori_remove() {
  var url = shiori_normalizeURL(gBrowser.currentURI.spec);
	for(var i = shiori_array.length-2; i>=0; i-=2){
		if(shiori_array[i] == url){
			shiori_array.splice(i, 2);
		}
	}
	shiori_setPref(shiori_array);
	shiori_makeMenu();
}

function shiori_removeAll() {
	shiori_array = new Array();
	shiori_setPref(shiori_array);
	shiori_makeMenu();
}

function shiori_memorize() {
  var url = shiori_normalizeURL(gBrowser.currentURI.spec);
	shiori_remove();
	shiori_array.push(url);
	shiori_array.push(gBrowser.contentWindow.scrollY);
	shiori_setPref(shiori_array);
	shiori_makeMenu();
}

function shiori_load() {
	var url = shiori_normalizeURL(gBrowser.currentURI.spec);
	for(var i=0; i<shiori_array.length; i+=2){
		if(shiori_array[i] == url){
			gBrowser.contentWindow.scrollTo(0, shiori_array[i+1]);
			break;
		}
	}
}

function shiori_makeMenu() {
 	var mem = document.getElementById("shioriMemorizeMenu");
 	var sep1 = document.getElementById("shioriMenuSeparator1");
 	var sep2 = document.getElementById("shioriMenuSeparator2");
 	var rmv = document.getElementById("shioriRemoveMenu");
 	var rmva = document.getElementById("shioriRemoveAllMenu");
 	var res = document.getElementById("shioriRestoreMenu");

 	var parent = document.getElementById("ShioriMenuPopup");
 	for(var i=parent.childNodes.length-1; i>=0; i--){
		var node = parent.childNodes.item(i);
		if(node != mem && node != sep1 && node != sep2 &&
			node != rmv && node != rmva && node != res){
			parent.removeChild(node);
		}
	}

	for(var i=0; i<shiori_array.length; i+=2){
  	var url = shiori_array[i];
  	var node = document.getElementById("shioriRestoreMenu").cloneNode(false);
  	node.id = "shioriRestoreMenu" + i;
  	node.label = url;
  	node.setAttribute("accesskey", (i/2) + 1);
  	node.setAttribute("oncommand", 
  		'gBrowser.selectedTab = gBrowser.addTab(this.label, null);');
  	node.setAttribute("hidden", "false");
  	parent.insertBefore(node, sep2);
  }
}

function shiori_getPrefBranch(){
	if(!shiori_pref_branch_cache){
		shiori_pref_branch_cache = Components.classes["@mozilla.org/preferences-service;1"]
		                           .getService(Components.interfaces.nsIPrefBranch);
	}
	return shiori_pref_branch_cache;
}
var shiori_pref_branch_cache = null;

function shiori_setPref(array){
	var str = "";
	if(array.length > 0){ str = array.join(" "); }
	var supportsString = Components.classes["@mozilla.org/supports-string;1"]
		.createInstance(Components.interfaces.nsISupportsString);
	supportsString.data = str;
	shiori_getPrefBranch().setComplexValue("skz.shiori.data",
		Components.interfaces.nsISupportsString, supportsString);
}

function shiori_getPref(){
	try{
		var str = shiori_getPrefBranch().getComplexValue("skz.shiori.data",
			Components.interfaces.nsISupportsString).data;
		if(str == ""){ return new Array(); }
		return str.split(" ");
	}catch(e){
		return new Array();
	}
}

function shiori_init() {
	if(shiori_array == null){
		shiori_array = shiori_getPref();
		shiori_makeMenu();
	}
	shiori_load();
}
